//
// Created by Tom on 08/03/2023.
//

#ifndef TYPON_COMPLEX_HPP
#define TYPON_COMPLEX_HPP

#include <complex>
#include <ostream>

#include "print.hpp"

using PyComplex = std::complex<double>;

PyComplex operator+(int a, const PyComplex &b) { return PyComplex(a) + b; }

PyComplex operator-(int a, const PyComplex &b) { return PyComplex(a) - b; }

template <> void print_to<PyComplex>(const PyComplex &x, std::ostream &s) {
  if (x.real() == 0) {
    s << x.imag() << "j";
  } else {
    s << '(' << x.real() << "+" << x.imag() << "j)";
  }
}

#endif // TYPON_COMPLEX_HPP
