# coding: utf-8
import ast

from transpiler.phases.emit_cpp import NodeVisitor


class SearchVisitor(NodeVisitor):
    def missing_impl(self, node):
        if not hasattr(node, "__dict__"):
            return
        for val in node.__dict__.values():
            if isinstance(val, list):
                for item in val:
                    if isinstance(val, ast.AST):
                        yield from self.visit(item)
            elif isinstance(val, ast.AST):
                yield from self.visit(val)

    def match(self, node) -> bool:
        return next(self.visit(node), False)
